/******************************************************************************
 *
 *
 *
 * Copyright (C) 1997-2015 by Dimitri van Heesch.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation under the terms of the GNU General Public License is hereby
 * granted. No representations are made about the suitability of this software
 * for any purpose. It is provided "as is" without express or implied warranty.
 * See the GNU General Public License for more details.
 *
 * Documents produced by analyze are derivative works derived from the
 * input used in their production; they are not affected by this license.
 *
 */

#ifndef TRANSLATOR_VI_H
#define TRANSLATOR_VI_H

/*
 * 17 Oct 2008 : Translation to Vietnamese by
 *               Đặng Minh Tuấn <tuanvietkey@gmail.com>
 *
 */


/*!
 When defining a translator class for the new language, follow
 the description in the documentation.  One of the steps says
 that you should copy the translator_en.h (this) file to your
 translator_xx.h new file.  Your new language should use the
 Translator class as the base class.  This means that you need to
 implement exactly the same (pure virtual) override methods as the
 TranslatorEnglish does.  Because of this, it is a good idea to
 start with the copy of TranslatorEnglish and replace the strings
 one by one.

 It is not necessary to include "translator.h" or
 "translator_adapter.h" here.  The files are included in the
 language.cpp correctly.  Not including any of the mentioned
 files frees the maintainer from thinking about whether the
 first, the second, or both files should be included or not, and
 why.  This holds namely for localized translators because their
 base class is changed occasionally to adapter classes when the
 Translator class changes the interface, or back to the
 Translator class (by the local maintainer) when the localized
 translator is made up-to-date again.
*/
class TranslatorVietnamese : public TranslatorAdapter_1_6_0
{
  public:

    // --- Language control methods -------------------

    /*! Used for identification of the language. The identification
     * should not be translated. It should be replaced by the name
     * of the language in English using lower-case characters only
     * (e.g. "czech", "japanese", "russian", etc.). It should be equal to
     * the identification used in language.cpp.
     */
    OGString idLanguage() override
    { return "vietnamese"; }

    /*! Used to get the LaTeX command(s) for the language support.
     *  This method should return string with commands that switch
     *  LaTeX to the desired language.  For example
     *  <pre>"\\usepackage[german]{babel}\n"
     *  </pre>
     *  or
     *  <pre>"\\usepackage{polski}\n"
     *  "\\usepackage[latin2]{inputenc}\n"
     *  "\\usepackage[T1]{fontenc}\n"
     *  </pre>
     *
     * The English LaTeX does not use such commands.  Because of this
     * the empty string is returned in this implementation.
     */
    OGString latexLanguageSupportCommand() override
    {
      return
        "\\usepackage[vietnamese]{babel}\n";
    }
    OGString latexFontenc() override
    {
      return "";
    }
    OGString latexCommandName() override
    {
      return p_latexCommandName("xelatex");
    }
    OGString trISOLang() override
    {
      return "vi";
    }
    OGString getLanguageString() override
    {
      return "0x42A Vietnamese";
    }
    // --- Language translation methods -------------------

    /*! used in the compound documentation before a list of related functions. */
    OGString trRelatedFunctions() override
    { return "Những hàm liên quan"; }

    /*! subscript for the related functions. */
    OGString trRelatedSubscript() override
    { return "(Chú ý những hàm này không phải là hàm thành viên.)"; }

    /*! header that is put before the detailed description of files, classes and namespaces. */
    OGString trDetailedDescription() override
    { return "Mô tả chi tiết"; }

    /*! header that is used when the summary tag is missing inside the details tag */
    OGString trDetails() override
    { return "Chi tiết"; }

    /*! header that is put before the list of typedefs. */
    OGString trMemberTypedefDocumentation() override
    { return "Thông tin về Member Typedef"; }

    /*! header that is put before the list of enumerations. */
    OGString trMemberEnumerationDocumentation() override
    { return "Thông tin về Member Enumeration"; }

    /*! header that is put before the list of member functions. */
    OGString trMemberFunctionDocumentation() override
    { return "Thông tin về hàm thành viên"; }

    /*! header that is put before the list of member attributes. */
    OGString trMemberDataDocumentation() override
    {
      if (Config_getBool(OPTIMIZE_OUTPUT_FOR_C))
      {
        return "Thông tin về trường";
      }
      else
      {
        return "Thông tin về Member Data";
      }
    }

    /*! this is the text of a link put after brief descriptions. */
    OGString trMore() override
    { return "Tiếp..."; }

    /*! put in the class documentation */
    OGString trListOfAllMembers() override
    { return "Liệt kê tất cả các thành viên"; }

    /*! used as the title of the "list of all members" page of a class */
    OGString trMemberList() override
    { return "Danh sách thành viên"; }

    /*! this is the first part of a sentence that is followed by a class name */
    OGString trThisIsTheListOfAllMembers() override
    { return "Danh sách các thành viên đầy đủ cho"; }

    /*! this is the remainder of the sentence after the class name */
    OGString trIncludingInheritedMembers() override
    { return ", cùng với tất cả các thành viên kế thừa."; }

    /*! this is put at the author sections at the bottom of man pages.
     *  parameter s is name of the project name.
     */
    OGString trGeneratedAutomatically(const OGString &s) override
    { OGString result="Được tạo ra bởi analyze";
      if (!s.isEmpty()) result+=" cho "+s;
      result+=" từ mã nguồn.";
      return result;
    }

    /*! put after an enum name in the list of all members */
    OGString trEnumName() override
    { return "tên enum"; }

    /*! put after an enum value in the list of all members */
    OGString trEnumValue() override
    { return "giá trị enum"; }

    /*! put after an undocumented member in the list of all members */
    OGString trDefinedIn() override
    { return "được định nghĩa trong"; }

    // quick reference sections

    /*! This is put above each page as a link to the list of all groups of
     *  compounds or files (see the \\group command).
     */
    OGString trModules() override
    { return "Các Modules"; }

    /*! This is put above each page as a link to the class hierarchy */
    OGString trClassHierarchy() override
    { return "Kiến trúc Class"; }

    /*! This is put above each page as a link to the list of annotated classes */
    OGString trCompoundList() override
    {
      if (Config_getBool(OPTIMIZE_OUTPUT_FOR_C))
      {
        return "Cấu trúc cơ sở dữ liệu (Data Structures)";
      }
      else
      {
        return "Danh mục các Class";
      }
    }

    /*! This is put above each page as a link to the list of documented files */
    OGString trFileList() override
    { return "Danh mục File"; }

    /*! This is put above each page as a link to all members of compounds. */
    OGString trCompoundMembers() override
    {
      if (Config_getBool(OPTIMIZE_OUTPUT_FOR_C))
      {
        return "Các trường dữ liệu";
      }
      else
      {
        return "Các thành viên của Class";
      }
    }

    /*! This is put above each page as a link to all members of files. */
    OGString trFileMembers() override
    {
      if (Config_getBool(OPTIMIZE_OUTPUT_FOR_C))
      {
        return "Toàn cục";
      }
      else
      {
        return "File thành viên";
      }
    }

    /*! This is put above each page as a link to all related pages. */
    OGString trRelatedPages() override
    { return "Các trang liên quan"; }

    /*! This is put above each page as a link to all examples. */
    OGString trExamples() override
    { return "Các ví dụ"; }

    /*! This is put above each page as a link to the search engine. */
    OGString trSearch() override
    { return "Tìm kiếm"; }

    /*! This is an introduction to the class hierarchy. */
    OGString trClassHierarchyDescription() override
    { return "Danh sách kế thừa đã được sắp xếp theo ABC, "
             "nhưng chưa đầy đủ:";
    }

    /*! This is an introduction to the list with all files. */
    OGString trFileListDescription(bool extractAll) override
    {
      OGString result="Danh mục đầy đủ tất cả các ";
      if (!extractAll) result+="(đã được biên soạn) ";
      result+="files cùng với các mô tả tóm tắt:";
      return result;
    }

    /*! This is an introduction to the annotated compound list. */
    OGString trCompoundListDescription() override
    {

      if (Config_getBool(OPTIMIZE_OUTPUT_FOR_C))
      {
        return "Đây là cấu trúc cơ sở dữ liệu với mô tả tóm tắt:";
      }
      else if (Config_getBool(OPTIMIZE_OUTPUT_SLICE))
      {
        return "Đây là các classes với các mô tả tóm tắt:";
      }
      else
      {
        return "Đây là các classes, structs, "
               "unions và interfaces với các mô tả tóm tắt:";
      }
    }

    /*! This is an introduction to the page with all class members. */
    OGString trCompoundMembersDescription(bool extractAll) override
    {
      OGString result="Danh mục tất cả các ";
      if (!extractAll)
      {
        result+="(đã được mô tả) ";
      }
      if (Config_getBool(OPTIMIZE_OUTPUT_FOR_C))
      {
        result+="struct và union fields";
      }
      else
      {
        result+="class members";
      }
      result+=" cùng với các các liên kết đến ";
      if (!extractAll)
      {
        if (Config_getBool(OPTIMIZE_OUTPUT_FOR_C))
        {
          result+="Thông tin về struct/union cho từng trường:";
        }
        else
        {
          result+="Thông tin về class cho từng thành viên:";
        }
      }
      else
      {
        if (Config_getBool(OPTIMIZE_OUTPUT_FOR_C))
        {
          result+="các structures/unions thuộc:";
        }
        else
        {
          result+="các lớp thuộc:";
        }
      }
      return result;
    }

    /*! This is an introduction to the page with all file members. */
    OGString trFileMembersDescription(bool extractAll) override
    {
      OGString result="Danh sách tất cả các ";
      if (!extractAll) result+="(đã được mô tat) ";

      if (Config_getBool(OPTIMIZE_OUTPUT_FOR_C))
      {
        result+="functions, variables, defines, enums, và typedefs";
      }
      else
      {
        result+="các file thành viên";
      }
      result+=" cùng với links tới ";
      if (extractAll)
        result+="các files thuộc:";
      else
        result+="tài liệu:";
      return result;
    }

    /*! This is an introduction to the page with the list of all examples */
    OGString trExamplesDescription() override
    { return "Danh sách tất cả các ví dụ:"; }

    /*! This is an introduction to the page with the list of related pages */
    OGString trRelatedPagesDescription() override
    { return "Danh sách tất cả các trang Thông tin có liên quan:"; }

    /*! This is an introduction to the page with the list of class/file groups */
    OGString trModulesDescription() override
    { return "Danh sách tất cả các thành viên:"; }

    // index titles (the project name is prepended for these)

    /*! This is used in HTML as the title of index.html. */
    OGString trDocumentation(const OGString &projName) override
    { return (!projName.isEmpty()?projName + " " : "") + "Thông tin"; }

    /*! This is used in LaTeX as the title of the chapter with the
     * index of all groups.
     */
    OGString trModuleIndex() override
    { return "Chỉ mục (Index) Module"; }

    /*! This is used in LaTeX as the title of the chapter with the
     * class hierarchy.
     */
    OGString trHierarchicalIndex() override
    { return "Hierarchical Index"; }

    /*! This is used in LaTeX as the title of the chapter with the
     * annotated compound index.
     */
    OGString trCompoundIndex() override
    {
      if (Config_getBool(OPTIMIZE_OUTPUT_FOR_C))
      {
        return "Index cấu trúc cơ sở dữ liệu";
      }
      else
      {
        return "Class Index";
      }
    }

    /*! This is used in LaTeX as the title of the chapter with the
     * list of all files.
     */
    OGString trFileIndex() override
    { return "File Index"; }

    /*! This is used in LaTeX as the title of the chapter containing
     *  the documentation of all groups.
     */
    OGString trModuleDocumentation() override
    { return "Thông tin về các Module"; }

    /*! This is used in LaTeX as the title of the chapter containing
     *  the documentation of all classes, structs and unions.
     */
    OGString trClassDocumentation() override
    {
      if (Config_getBool(OPTIMIZE_OUTPUT_FOR_C))
      {
        return "Thông tin về cấu trúc cơ sở dữ liệu";
      }
      else if (Config_getBool(OPTIMIZE_OUTPUT_VHDL))
      {
          return trDesignUnitDocumentation();
      }
      else
      {
        return "Thông tin về Class";
      }
    }

    /*! This is used in LaTeX as the title of the chapter containing
     *  the documentation of all files.
     */
    OGString trFileDocumentation() override
    { return "Thông tin về File"; }

    /*! This is used in LaTeX as the title of the document */
    OGString trReferenceManual() override
    { return "Thông tin tham chiếu"; }

    /*! This is used in the documentation of a file as a header before the
     *  list of defines
     */
    OGString trDefines() override
    { return "Định nghĩa"; }

    /*! This is used in the documentation of a file as a header before the
     *  list of typedefs
     */
    OGString trTypedefs() override
    { return "Typedefs"; }

    /*! This is used in the documentation of a file as a header before the
     *  list of enumerations
     */
    OGString trEnumerations() override
    { return "Enumerations"; }

    /*! This is used in the documentation of a file as a header before the
     *  list of (global) functions
     */
    OGString trFunctions() override
    { return "Các hàm"; }

    /*! This is used in the documentation of a file as a header before the
     *  list of (global) variables
     */
    OGString trVariables() override
    { return "Các biến"; }

    /*! This is used in the documentation of a file as a header before the
     *  list of (global) variables
     */
    OGString trEnumerationValues() override
    { return "Enumerator"; }

    /*! This is used in the documentation of a file before the list of
     *  documentation blocks for defines
     */
    OGString trDefineDocumentation() override
    { return "Thông tin về định nghĩa"; }

    /*! This is used in the documentation of a file/namespace before the list
     *  of documentation blocks for typedefs
     */
    OGString trTypedefDocumentation() override
    { return "Thông tin về Typedef"; }

    /*! This is used in the documentation of a file/namespace before the list
     *  of documentation blocks for enumeration types
     */
    OGString trEnumerationTypeDocumentation() override
    { return "Thông tin về Enumeration Type"; }

    /*! This is used in the documentation of a file/namespace before the list
     *  of documentation blocks for functions
     */
    OGString trFunctionDocumentation() override
    { return "Thông tin về hàm"; }

    /*! This is used in the documentation of a file/namespace before the list
     *  of documentation blocks for variables
     */
    OGString trVariableDocumentation() override
    { return "Thông tin về các biến"; }

    /*! This is used in the documentation of a file/namespace/group before
     *  the list of links to documented compounds
     */
    OGString trCompounds() override
    {
      if (Config_getBool(OPTIMIZE_OUTPUT_FOR_C))
      {
        return "Cấu trúc cơ sở dữ liệu";
      }
      else
      {
        return "Classes";
      }
    }

    /*! This is used in the standard footer of each page and indicates when
     *  the page was generated
     */
    OGString trGeneratedAt(const OGString &date,const OGString &projName) override
    {
      OGString result="Được biên soạn vào "+date;
      if (!projName.isEmpty()) result+=" cho mã nguồn dự án "+projName;
      result+=" bởi";
      return result;
    }

    /*! this text is put before a class diagram */
    OGString trClassDiagram(const OGString &clName) override
    {
      return "Sơ đồ kế thừa cho "+clName+":";
    }

    /*! this text is generated when the \\warning command is used. */
    OGString trWarning() override
    { return "Lưu ý"; }

    /*! this text is generated when the \\version command is used. */
    OGString trVersion() override
    { return "Phiên bản"; }

    /*! this text is generated when the \\date command is used. */
    OGString trDate() override
    { return "Ngày"; }

    /*! this text is generated when the \\return command is used. */
    OGString trReturns() override
    { return "Giá trị trả về"; }

    /*! this text is generated when the \\sa command is used. */
    OGString trSeeAlso() override
    { return "Xem thêm"; }

    /*! this text is generated when the \\param command is used. */
    OGString trParameters() override
    { return "Các tham số"; }

    /*! this text is generated when the \\exception command is used. */
    OGString trExceptions() override
    { return "Exceptions"; }

    /*! this text is used in the title page of a LaTeX document. */
    OGString trGeneratedBy() override
    { return "Được biên soạn bởi"; }

//////////////////////////////////////////////////////////////////////////
// new since 0.49-990307
//////////////////////////////////////////////////////////////////////////

    /*! used as the title of page containing all the index of all namespaces. */
    OGString trNamespaceList() override
    { return "Danh sách Namespace"; }

    /*! used as an introduction to the namespace list */
    OGString trNamespaceListDescription(bool extractAll) override
    {
      OGString result="Danh sách tất cả các ";
      if (!extractAll) result+="(đã được biên tập) ";
      result+="namespaces với mô tả tóm tắt:";
      return result;
    }

    /*! used in the class documentation as a header before the list of all
     *  friends of a class
     */
    OGString trFriends() override
    { return "Friends"; }

//////////////////////////////////////////////////////////////////////////
// new since 0.49-990405
//////////////////////////////////////////////////////////////////////////

    /*! used in the class documentation as a header before the list of all
     * related classes
     */
    OGString trRelatedFunctionDocumentation() override
    { return "Thông tin về Friends và các hàm liên quan"; }

//////////////////////////////////////////////////////////////////////////
// new since 0.49-990425
//////////////////////////////////////////////////////////////////////////

    /*! used as the title of the HTML page of a class/struct/union */
    OGString trCompoundReference(const OGString &clName,
                                    ClassDef::CompoundType compType,
                                    bool isTemplate) override
    {
      OGString result=clName;
      switch(compType)
      {
        case ClassDef::Class:      result+=" Class"; break;
        case ClassDef::Struct:     result+=" Struct"; break;
        case ClassDef::Union:      result+=" Union"; break;
        case ClassDef::Interface:  result+=" Interface"; break;
        case ClassDef::Protocol:   result+=" Protocol"; break;
        case ClassDef::Category:   result+=" Category"; break;
        case ClassDef::Exception:  result+=" Exception"; break;
        default: break;
      }
      if (isTemplate) result+=" Template";
      result+=" Tham chiếu";
      return result;
    }

    /*! used as the title of the HTML page of a file */
    OGString trFileReference(const OGString &fileName) override
    {
      OGString result=fileName;
      result+=" File Tham chiếu";
      return result;
    }

    /*! used as the title of the HTML page of a namespace */
    OGString trNamespaceReference(const OGString &namespaceName) override
    {
      OGString result=namespaceName;
      result+=" Namespace Tham chiếu";
      return result;
    }

    OGString trPublicMembers() override
    { return "Các hàm thành viên Public"; }
    OGString trPublicSlots() override
    { return "Public Slots"; }
    OGString trSignals() override
    { return "Signals"; }
    OGString trStaticPublicMembers() override
    { return "Các hàm Static Public"; }
    OGString trProtectedMembers() override
    { return "Các hàm thành viên Protected"; }
    OGString trProtectedSlots() override
    { return "Protected Slots"; }
    OGString trStaticProtectedMembers() override
    { return "Các hàm thành viên Static Protected"; }
    OGString trPrivateMembers() override
    { return "Các hàm thành viên Private"; }
    OGString trPrivateSlots() override
    { return "Private Slots"; }
    OGString trStaticPrivateMembers() override
    { return "Các hàm thành viên Static Private"; }

    /*! this function is used to produce a comma-separated list of items.
     *  use generateMarker(i) to indicate where item i should be put.
     */
    OGString trWriteList(int numEntries) override
    {
      OGString result;
      // the inherits list contain `numEntries' classes
      for (int i=0;i<numEntries;i++)
      {
        // use generateMarker to generate placeholders for the class links!
        result+=generateMarker(i); // generate marker for entry i in the list
                                   // (order is left to right)

        if (i!=numEntries-1)  // not the last entry, so we need a separator
        {
          if (i<numEntries-2) // not the fore last entry
            result+=", ";
          else                // the fore last entry
            result+=", và ";
        }
      }
      return result;
    }

    /*! used in class documentation to produce a list of base classes,
     *  if class diagrams are disabled.
     */
    OGString trInheritsList(int numEntries) override
    {
      return "Kế thừa "+trWriteList(numEntries)+".";
    }

    /*! used in class documentation to produce a list of super classes,
     *  if class diagrams are disabled.
     */
    OGString trInheritedByList(int numEntries) override
    {
      return "Được kế thừa bởi "+trWriteList(numEntries)+".";
    }

    /*! used in member documentation blocks to produce a list of
     *  members that are hidden by this one.
     */
    OGString trReimplementedFromList(int numEntries) override
    {
      return "Được thực thi lại từ "+trWriteList(numEntries)+".";
    }

    /*! used in member documentation blocks to produce a list of
     *  all member that overwrite the implementation of this member.
     */
    OGString trReimplementedInList(int numEntries) override
    {
      return "Được thực thi lại trong "+trWriteList(numEntries)+".";
    }

    /*! This is put above each page as a link to all members of namespaces. */
    OGString trNamespaceMembers() override
    { return "Thành viên Namespace"; }

    /*! This is an introduction to the page with all namespace members */
    OGString trNamespaceMemberDescription(bool extractAll) override
    {
      OGString result="Danh sách tất cả các ";
      if (!extractAll) result+="(đã được biên soạn) ";
      result+="các thành viên namespace cùng với link tới ";
      if (extractAll)
        result+="Thông tin namespace cho từng thành viên:";
      else
        result+=" namespaces mà phụ thuộc bởi:";
      return result;
    }
    /*! This is used in LaTeX as the title of the chapter with the
     *  index of all namespaces.
     */
    OGString trNamespaceIndex() override
    { return "Namespace Index"; }

    /*! This is used in LaTeX as the title of the chapter containing
     *  the documentation of all namespaces.
     */
    OGString trNamespaceDocumentation() override
    { return "Thông tin về Namespace"; }

//////////////////////////////////////////////////////////////////////////
// new since 0.49-990522
//////////////////////////////////////////////////////////////////////////

    /*! This is used in the documentation before the list of all
     *  namespaces in a file.
     */
    OGString trNamespaces() override
    { return "Namespaces"; }

//////////////////////////////////////////////////////////////////////////
// new since 0.49-990728
//////////////////////////////////////////////////////////////////////////

    /*! This is put at the bottom of a class documentation page and is
     *  followed by a list of files that were used to generate the page.
     */
    OGString trGeneratedFromFiles(ClassDef::CompoundType compType,bool) override
    { // here s is one of " Class", " Struct" or " Union"
      // single is true implies a single file
      OGString result="Thông tin cho ";
      switch(compType)
      {
        case ClassDef::Class:      result+="class"; break;
        case ClassDef::Struct:     result+="struct"; break;
        case ClassDef::Union:      result+="union"; break;
        case ClassDef::Interface:  result+="interface"; break;
        case ClassDef::Protocol:   result+="protocol"; break;
        case ClassDef::Category:   result+="category"; break;
        case ClassDef::Exception:  result+="exception"; break;
        default: break;
      }
      result+=" được biên soạn từ các file sau đây";
      result+=":";
      return result;
    }

//////////////////////////////////////////////////////////////////////////
// new since 0.49-990901
//////////////////////////////////////////////////////////////////////////

    /*! This is used as the heading text for the retval command. */
    OGString trReturnValues() override
    { return "Các giá trị trả về"; }

    /*! This is in the (quick) index as a link to the main page (index.html)
     */
    OGString trMainPage() override
    { return "Tranh chính"; }

    /*! This is used in references to page that are put in the LaTeX
     *  documentation. It should be an abbreviation of the word page.
     */
    OGString trPageAbbreviation() override
    { return "tr."; }

//////////////////////////////////////////////////////////////////////////
// new since 0.49-991003
//////////////////////////////////////////////////////////////////////////

    OGString trDefinedAtLineInSourceFile() override
    {
      return "Định nghĩa tại dòng @0 trong file @1.";
    }
    OGString trDefinedInSourceFile() override
    {
      return "Định nghĩa trong file @0.";
    }

//////////////////////////////////////////////////////////////////////////
// new since 0.49-991205
//////////////////////////////////////////////////////////////////////////

    OGString trDeprecated() override
    {
      return "Không tán thành";
    }

//////////////////////////////////////////////////////////////////////////
// new since 1.0.0
//////////////////////////////////////////////////////////////////////////

    /*! this text is put before a collaboration diagram */
    OGString trCollaborationDiagram(const OGString &clName) override
    {
      return "Sơ đồ liên kết cho "+clName+":";
    }
    /*! this text is put before an include dependency graph */
    OGString trInclDepGraph(const OGString &fName) override
    {
      return "Kèm theo graph phụ thuộc cho "+fName+":";
    }
    /*! header that is put before the list of constructor/destructors. */
    OGString trConstructorDocumentation() override
    {
      return "Thông tin về Constructor và Destructor";
    }
    /*! Used in the file documentation to point to the corresponding sources. */
    OGString trGotoSourceCode() override
    {
      return "Tới mã nguồn của file này.";
    }
    /*! Used in the file sources to point to the corresponding documentation. */
    OGString trGotoDocumentation() override
    {
      return "Tới Thông tin của file này.";
    }
    /*! Text for the \\pre command */
    OGString trPrecondition() override
    {
      return "Điều kiện trước";
    }
    /*! Text for the \\post command */
    OGString trPostcondition() override
    {
      return "Điều kiện sau";
    }
    /*! Text for the \\invariant command */
    OGString trInvariant() override
    {
      return "Bất biến";
    }
    /*! Text shown before a multi-line variable/enum initialization */
    OGString trInitialValue() override
    {
      return "Giá trị khởi tạo:";
    }
    /*! Text used the source code in the file index */
    OGString trCode() override
    {
      return "mã nguồn";
    }
    OGString trGraphicalHierarchy() override
    {
      return "Kiến trúc đồ họa của Class";
    }
    OGString trGotoGraphicalHierarchy() override
    {
      return "Tới kiến trúc đồ họa của Class";
    }
    OGString trGotoTextualHierarchy() override
    {
      return "Tới kiến trúc text của Class";
    }
    OGString trPageIndex() override
    {
      return "Chỉ mục trang";
    }

//////////////////////////////////////////////////////////////////////////
// new since 1.1.0
//////////////////////////////////////////////////////////////////////////

    OGString trNote() override
    {
      return "Ghi chú";
    }
    OGString trPublicTypes() override
    {
      return "Public Types";
    }
    OGString trPublicAttribs() override
    {
      if (Config_getBool(OPTIMIZE_OUTPUT_FOR_C))
      {
        return "các trường đữ liệu";
      }
      else
      {
        return "Các thuộc tính Public";
      }
    }
    OGString trStaticPublicAttribs() override
    {
      return "Các thuộc tính Static Public";
    }
    OGString trProtectedTypes() override
    {
      return "Các kiểu Protected";
    }
    OGString trProtectedAttribs() override
    {
      return "các thuộc tính Protected";
    }
    OGString trStaticProtectedAttribs() override
    {
      return "Các thuộc tính Static Protected";
    }
    OGString trPrivateTypes() override
    {
      return "Các kiểu Private";
    }
    OGString trPrivateAttribs() override
    {
      return "Các thuộc tính Private";
    }
    OGString trStaticPrivateAttribs() override
    {
      return "Các thuộc tính Static Private";
    }

//////////////////////////////////////////////////////////////////////////
// new since 1.1.3
//////////////////////////////////////////////////////////////////////////

    /*! Used as a marker that is put before a \\todo item */
    OGString trTodo() override
    {
      return "Mục tiêu";
    }
    /*! Used as the header of the todo list */
    OGString trTodoList() override
    {
      return "Danh sách hàng mục cần thực hiện";
    }

//////////////////////////////////////////////////////////////////////////
// new since 1.1.4
//////////////////////////////////////////////////////////////////////////

    OGString trReferencedBy() override
    {
      return "Tham chiếu bởi";
    }
    OGString trRemarks() override
    {
      return "Ghi chú";
    }
    OGString trAttention() override
    {
      return "Chú ý";
    }
    OGString trInclByDepGraph() override
    {
      return "Đồ thị này biểu thị những file nào trực tiếp hoặc"
             "không trực tiếp bao gồm file này:";
    }
    OGString trSince() override
    {
      return "Từ";
    }

//////////////////////////////////////////////////////////////////////////
// new since 1.1.5
//////////////////////////////////////////////////////////////////////////

    /*! title of the graph legend page */
    OGString trLegendTitle() override
    {
      return "Chú giải Graph";
    }
    /*! page explaining how the dot graph's should be interpreted
     *  The %A in the text below are to prevent link to classes called "A".
     */
    OGString trLegendDocs() override
    {
      return
        "Trang này giải nghĩa các biểu đồ được biên soạn bởi "
        " analyze.<p>\n"
        "Hãy xem xét các ví dụ sau:\n"
        "\\code\n"
        "/*! Các lướp không thấy được bởi sự cắt ngắn */\n"
        "Lớp không nhìn thấy class { };\n\n"
        "/*! class bị cắt, quan hệ kế thừa bị ẩn */\n"
        "class bị cắt : bị ẩn toàn cục { };\n\n"
        "/* Class không được mô tả với các chú giải analyze */\n"
        "class không được mô tả { };\n\n"
        "/*! Class được kế thừa sử dụng các kế thừa public */\n"
        "class PublicBase : public Truncated { };\n\n"
        "/*!  template class */\n"
        "template<class T> class Templ { };\n\n"
        "/*! Class được kế thừa sử dụng kế thừa protected */\n"
        "class ProtectedBase { };\n\n"
        "/*! Class được kế thừa sử dụng kế thừa protected private */\n"
        "class PrivateBase { };\n\n"
        "/*! Class được sử dụng bởi các class kế thừa */\n"
        "class được sử dụng { };\n\n"
        "/*! Super class kế thừa một số các class khác */\n"
        "class được kế thừa : public PublicBase,\n"
        "                  protected ProtectedBase,\n"
        "                  private PrivateBase,\n"
        "                  public Undocumented,\n"
        "                  public Templ<int>\n"
        "{\n"
        "  private:\n"
        "    Used *m_usedClass;\n"
        "};\n"
        "\\endcode\n"
        "Kết quả trong biểu đồ sau đây:"
        "<p><center><img alt=\"\" src=\"graph_legend."+getDotImageExtension()+"\"></center>\n"
        "<p>\n"
        "Các hộp trong biểu đồ trên có ý nghĩa như sau:\n"
        "<ul>\n"
        "<li>%Hộp màu xám biểu thị cấu trúc clas cho "
        "biểu đồ được thể hiện.\n"
        "<li>%Hộp có khung mầu đen biểu thị struct hoặc class được mô tả.\n"
        "<li>%Hộp có khung mầu xám biểu thị struct hoặc class chưa được mô tả.\n"
        "<li>%Hộp có khung mầu đỏ biểu thị struct hoặc class được mổ tả "
        "khi mà không phải tất cả các quan hệ kế thừa/containment được biển diễn.. %Biểu đồ bị "
        "cắt nếu nó không nằm trọn trong các biên được cho trước..\n"
        "</ul>\n"
        "Các mũi tên có ý nghĩa như sau::\n"
        "<ul>\n"
        "<li>%Mũi tên mầu xanh đậm biểu thị các quan hệ kế thừa công khai "
        "giữa 2 class.\n"
        "<li>%Mũi tên màu xanh lá cây đậm biểu thị kế thừa được bảo về (protected).\n"
        "<li>%Mũi tên đỏ đậm biểu thị kế thừa dạng private.\n"
        "<li>%Mũi tên màu hồng đứt quảng biểu thị class được sử dụng "
        "bởi class khác. Mũi tên được gán nhãn với các giá trị "
        "mà các calsss hoặc struct được truy cập tới.\n"
        "<li>%Mũi tên vàng đắt quãng được thị quan hệ giữa template instance và "
        "template class được dẫn xuất từ đó. Mũi tên được gán nhãn với "
        "tham số của template.\n"
        "</ul>\n";
    }
    /*! text for the link to the legend page */
    OGString trLegend() override
    {
      return "Chú giải";
    }

//////////////////////////////////////////////////////////////////////////
// new since 1.2.0
//////////////////////////////////////////////////////////////////////////

    /*! Used as a marker that is put before a test item */
    OGString trTest() override
    {
      return "Test";
    }
    /*! Used as the header of the test list */
    OGString trTestList() override
    {
      return "Danh sách Test";
    }

//////////////////////////////////////////////////////////////////////////
// new since 1.2.2
//////////////////////////////////////////////////////////////////////////

    /*! Used as a section header for IDL properties */
    OGString trProperties() override
    {
      return "Thuộc tính";
    }
    /*! Used as a section header for IDL property documentation */
    OGString trPropertyDocumentation() override
    {
      return "Thông tin thuộc tính (Property)";
    }

//////////////////////////////////////////////////////////////////////////
// new since 1.2.4
//////////////////////////////////////////////////////////////////////////

    /*! Used for Java classes in the summary section of Java packages */
    OGString trClasses() override
    {
      if (Config_getBool(OPTIMIZE_OUTPUT_FOR_C))
      {
        return "Cấu trúc dữ liệu";
      }
      else
      {
        return "Classes";
      }
    }
    /*! Used as the title of a Java package */
    OGString trPackage(const OGString &name) override
    {
      return "Gói "+name;
    }
    /*! The description of the package index page */
    OGString trPackageListDescription() override
    {
      return "Danh sách các gói cùng với mô tả tóm tắt (khi có thể có):";
    }
    /*! The link name in the Quick links header for each page */
    OGString trPackages() override
    {
      return "Các gói";
    }
    /*! Text shown before a multi-line define */
    OGString trDefineValue() override
    {
      return "Giá trị:";
    }

//////////////////////////////////////////////////////////////////////////
// new since 1.2.5
//////////////////////////////////////////////////////////////////////////

    /*! Used as a marker that is put before a \\bug item */
    OGString trBug() override
    {
      return "Lỗi";
    }
    /*! Used as the header of the bug list */
    OGString trBugList() override
    {
      return "Danh sách lỗi";
    }

//////////////////////////////////////////////////////////////////////////
// new since 1.2.6
//////////////////////////////////////////////////////////////////////////

    /*! Used as ansicpg for RTF file
     *
     * The following table shows the correlation of Charset name, Charset Value and
     * <pre>
     * Codepage number:
     * Charset Name       Charset Value(hex)  Codepage number
     * ------------------------------------------------------
     * DEFAULT_CHARSET           1 (x01)
     * SYMBOL_CHARSET            2 (x02)
     * OEM_CHARSET             255 (xFF)
     * ANSI_CHARSET              0 (x00)            1252
     * RUSSIAN_CHARSET         204 (xCC)            1251
     * EE_CHARSET              238 (xEE)            1250
     * GREEK_CHARSET           161 (xA1)            1253
     * TURKISH_CHARSET         162 (xA2)            1254
     * BALTIC_CHARSET          186 (xBA)            1257
     * HEBREW_CHARSET          177 (xB1)            1255
     * ARABIC _CHARSET         178 (xB2)            1256
     * SHIFTJIS_CHARSET        128 (x80)             932
     * HANGEUL_CHARSET         129 (x81)             949
     * GB2313_CHARSET          134 (x86)             936
     * CHINESEBIG5_CHARSET     136 (x88)             950
     * </pre>
     *
     */
    OGString trRTFansicp() override
    {
      return "1258";
    }


    /*! Used as ansicpg for RTF fcharset
     *  \see trRTFansicp() for a table of possible values.
     */
    OGString trRTFCharSet() override
    {
      return "163";
    }

    /*! Used as header RTF general index */
    OGString trRTFGeneralIndex() override
    {
      return "Chỉ số";
    }

    /*! This is used for translation of the word that will possibly
     *  be followed by a single name or by a list of names
     *  of the category.
     */
    OGString trClass(bool first_capital, bool singular) override
    {
      return createNoun(first_capital, singular, "class", "es");
    }

    /*! This is used for translation of the word that will possibly
     *  be followed by a single name or by a list of names
     *  of the category.
     */
    OGString trFile(bool first_capital, bool singular) override
    {
      return createNoun(first_capital, singular, "file", "s");
    }

    /*! This is used for translation of the word that will possibly
     *  be followed by a single name or by a list of names
     *  of the category.
     */
    OGString trNamespace(bool first_capital, bool singular) override
    {
      return createNoun(first_capital, singular, "namespace", "s");
    }

    /*! This is used for translation of the word that will possibly
     *  be followed by a single name or by a list of names
     *  of the category.
     */
    OGString trGroup(bool first_capital, bool singular) override
    {
      return createNoun(first_capital, singular, "group", "s");
    }

    /*! This is used for translation of the word that will possibly
     *  be followed by a single name or by a list of names
     *  of the category.
     */
    OGString trPage(bool first_capital, bool singular) override
    {
      return createNoun(first_capital, singular, "trang", "");
    }

    /*! This is used for translation of the word that will possibly
     *  be followed by a single name or by a list of names
     *  of the category.
     */
    OGString trMember(bool first_capital, bool singular) override
    {
      return createNoun(first_capital, singular, "member", "s");
    }

    /*! This is used for translation of the word that will possibly
     *  be followed by a single name or by a list of names
     *  of the category.
     */
    OGString trGlobal(bool first_capital, bool singular) override
    {
      return createNoun(first_capital, singular, "global", "s");
    }

//////////////////////////////////////////////////////////////////////////
// new since 1.2.7
//////////////////////////////////////////////////////////////////////////

    /*! This text is generated when the \\author command is used and
     *  for the author section in man pages. */
    OGString trAuthor(bool first_capital, bool singular) override
    {
      return createNoun(first_capital, singular, "tác giả", "");
    }

//////////////////////////////////////////////////////////////////////////
// new since 1.2.11
//////////////////////////////////////////////////////////////////////////

    /*! This text is put before the list of members referenced by a member
     */
    OGString trReferences() override
    {
      return "Tham chiếu";
    }

//////////////////////////////////////////////////////////////////////////
// new since 1.2.13
//////////////////////////////////////////////////////////////////////////

    /*! used in member documentation blocks to produce a list of
     *  members that are implemented by this one.
     */
    OGString trImplementedFromList(int numEntries) override
    {
      return "Thực hiện "+trWriteList(numEntries)+".";
    }

    /*! used in member documentation blocks to produce a list of
     *  all members that implement this abstract member.
     */
    OGString trImplementedInList(int numEntries) override
    {
      return "Được thực hiện trong "+trWriteList(numEntries)+".";
    }

//////////////////////////////////////////////////////////////////////////
// new since 1.2.16
//////////////////////////////////////////////////////////////////////////

    /*! used in RTF documentation as a heading for the Table
     *  of Contents.
     */
    OGString trRTFTableOfContents() override
    {
      return "Mục lục";
    }

//////////////////////////////////////////////////////////////////////////
// new since 1.2.17
//////////////////////////////////////////////////////////////////////////

    /*! Used as the header of the list of item that have been
     *  flagged deprecated
     */
    OGString trDeprecatedList() override
    {
      return "Danh sách Deprecated";
    }

//////////////////////////////////////////////////////////////////////////
// new since 1.2.18
//////////////////////////////////////////////////////////////////////////

    /*! Used as a header for declaration section of the events found in
     * a C# program
     */
    OGString trEvents() override
    {
      return "Sự kiện";
    }
    /*! Header used for the documentation section of a class' events. */
    OGString trEventDocumentation() override
    {
      return "Thông tin về sự kiện";
    }

//////////////////////////////////////////////////////////////////////////
// new since 1.3
//////////////////////////////////////////////////////////////////////////

    /*! Used as a heading for a list of Java class types with package scope.
     */
    OGString trPackageTypes() override
    {
      return "Kiểu gói";
    }
    /*! Used as a heading for a list of Java class functions with package
     * scope.
     */
    OGString trPackageFunctions() override
    {
      return "Các hàm Package";
    }
    OGString trPackageMembers() override
    {
      return "Members Package";
    }
    /*! Used as a heading for a list of static Java class functions with
     *  package scope.
     */
    OGString trStaticPackageFunctions() override
    {
      return "Các hàm Static Package";
    }
    /*! Used as a heading for a list of Java class variables with package
     * scope.
     */
    OGString trPackageAttribs() override
    {
      return "Các thuộc tính Package";
    }
    /*! Used as a heading for a list of static Java class variables with
     * package scope.
     */
    OGString trStaticPackageAttribs() override
    {
      return "Các thuộc tính Static Package";
    }

//////////////////////////////////////////////////////////////////////////
// new since 1.3.1
//////////////////////////////////////////////////////////////////////////

    /*! Used in the quick index of a class/file/namespace member list page
     *  to link to the unfiltered list of all members.
     */
    OGString trAll() override
    {
      return "Tất cả";
    }
    /*! Put in front of the call graph for a function. */
    OGString trCallGraph() override
    {
      return "Biểu đồ các lời gọi cho hàm này:";
    }

//////////////////////////////////////////////////////////////////////////
// new since 1.3.3
//////////////////////////////////////////////////////////////////////////

    /*! This string is used as the title for the page listing the search
     *  results.
     */
    OGString trSearchResultsTitle() override
    {
      return "Kết quả tìm kiếm";
    }
    /*! This string is put just before listing the search results. The
     *  text can be different depending on the number of documents found.
     *  Inside the text you can put the special marker $num to insert
     *  the number representing the actual number of search results.
     *  The @a numDocuments parameter can be either 0, 1 or 2, where the
     *  value 2 represents 2 or more matches. HTML markup is allowed inside
     *  the returned string.
     */
    OGString trSearchResults(int numDocuments) override
    {
      if (numDocuments==0)
      {
        return "Không có tài liệu nào thỏa mãn các truy vấn của bạn.";
      }
      else if (numDocuments==1)
      {
        return "Tìm thấy <b>1</b> tài liệu thỏa mã truy vấn của bạn.";
      }
      else
      {
        return "Tìm thấy tất cả <b>$num</b> tài liệu thỏa mã truy vấn của bạn. "
               "Hiển thị những thỏa mãn tốt nhất trước.";
      }
    }
    /*! This string is put before the list of matched words, for each search
     *  result. What follows is the list of words that matched the query.
     */
    OGString trSearchMatches() override
    {
      return "Các kết quả thỏa mãn đk:";
    }

//////////////////////////////////////////////////////////////////////////
// new since 1.3.8
//////////////////////////////////////////////////////////////////////////

    /*! This is used in HTML as the title of page with source code for file filename
     */
    OGString trSourceFile(const OGString& filename) override
    {
      return filename + " File nguồn";
    }

//////////////////////////////////////////////////////////////////////////
// new since 1.3.9
//////////////////////////////////////////////////////////////////////////

    /*! This is used as the name of the chapter containing the directory
     *  hierarchy.
     */
    OGString trDirIndex() override
    { return "Cấu trúc thư mục"; }

    /*! This is used as the name of the chapter containing the documentation
     *  of the directories.
     */
    OGString trDirDocumentation() override
    { return "Thông tin về thư mục"; }

    /*! This is used as the title of the directory index and also in the
     *  Quick links of an HTML page, to link to the directory hierarchy.
     */
    OGString trDirectories() override
    { return "Các thư mục"; }

    /*! This returns the title of a directory page. The name of the
     *  directory is passed via \a dirName.
     */
    OGString trDirReference(const OGString &dirName) override
    { OGString result=dirName; result+=" Tham chiếu thư mục"; return result; }

    /*! This returns the word directory with or without starting capital
     *  (\a first_capital) and in sigular or plural form (\a singular).
     */
    OGString trDir(bool first_capital, bool) override
    {
      return createNoun(first_capital, false, "thư mục", "");
    }

//////////////////////////////////////////////////////////////////////////
// new since 1.4.1
//////////////////////////////////////////////////////////////////////////

    /*! This text is added to the documentation when the \\overload command
     *  is used for a overloaded function.
     */
    OGString trOverloadText() override
    {
       return "Hàm thành viên dạng overloaded, "
              "được chỉ ra cho việc tra cứu dễ dàng. Nó khác với hàm ở trên"
              "chỉ ở chỗ những tham số nào nó chấp nhận.";
    }

//////////////////////////////////////////////////////////////////////////
// new since 1.4.6
//////////////////////////////////////////////////////////////////////////

    /*! This is used to introduce a caller (or called-by) graph */
    OGString trCallerGraph() override
    {
      return "Biểu đồ các lời gọi cho hàm này:";
    }

    /*! This is used in the documentation of a file/namespace before the list
     *  of documentation blocks for enumeration values
     */
    OGString trEnumerationValueDocumentation() override
    { return "Thông tin Enumerator"; }

//////////////////////////////////////////////////////////////////////////
// new since 1.5.4 (mainly for Fortran)
//////////////////////////////////////////////////////////////////////////

    /*! header that is put before the list of member subprograms (Fortran). */
    OGString trMemberFunctionDocumentationFortran() override
    { return "Thông tin về các hàm và các thủ tục thành viên"; }

    /*! This is put above each page as a link to the list of annotated data types (Fortran). */
    OGString trCompoundListFortran() override
    { return "Danh sách kiêu dữ liệu"; }

    /*! This is put above each page as a link to all members of compounds (Fortran). */
    OGString trCompoundMembersFortran() override
    { return "Trường dữ liệu"; }

    /*! This is an introduction to the annotated compound list (Fortran). */
    OGString trCompoundListDescriptionFortran() override
    { return "Kiểu dữ liệu với các mô tả tóm tắt:"; }

    /*! This is an introduction to the page with all data types (Fortran). */
    OGString trCompoundMembersDescriptionFortran(bool extractAll) override
    {
      OGString result="Danh sách tất cả ";
      if (!extractAll)
      {
        result+="(đã được mô tả) ";
      }
      result+="các kiểu dữ liệu thành viên";
      result+=" cùng với liên kết với ";
      if (!extractAll)
      {
         result+="Thông tin cấu trúc dữ liệu cho từng thành viên";
      }
      else
      {
         result+=" các kiểu dữ liệu thuộc:";
      }
      return result;
    }

    /*! This is used in LaTeX as the title of the chapter with the
     * annotated compound index (Fortran).
     */
    OGString trCompoundIndexFortran() override
    { return "Chỉ mục kiểu dữ liệu"; }

    /*! This is used in LaTeX as the title of the chapter containing
     *  the documentation of all data types (Fortran).
     */
    OGString trTypeDocumentation() override
    { return "Thông tin về kiểu dữ liệu"; }

    /*! This is used in the documentation of a file as a header before the
     *  list of (global) subprograms (Fortran).
     */
    OGString trSubprograms() override
    { return "Functions/Subroutines"; }

    /*! This is used in the documentation of a file/namespace before the list
     *  of documentation blocks for subprograms (Fortran)
     */
    OGString trSubprogramDocumentation() override
    { return "Thông tin về Function/Subroutine"; }

    /*! This is used in the documentation of a file/namespace/group before
     *  the list of links to documented compounds (Fortran)
     */
     OGString trDataTypes() override
    { return "Kiểu dữ liệu"; }

    /*! used as the title of page containing all the index of all modules (Fortran). */
    OGString trModulesList() override
    { return "Danh sách Modules"; }

    /*! used as an introduction to the modules list (Fortran) */
    OGString trModulesListDescription(bool extractAll) override
    {
      OGString result="Danh sách tất cả ";
      if (!extractAll) result+="(đã được mô tả) ";
      result+="các module với mô tả tóm tắt:";
      return result;
    }

    /*! used as the title of the HTML page of a module/type (Fortran) */
    OGString trCompoundReferenceFortran(const OGString &clName,
                                    ClassDef::CompoundType compType,
                                    bool isTemplate) override
    {
      OGString result=clName;
      switch(compType)
      {
        case ClassDef::Class:      result+=" Module"; break;
        case ClassDef::Struct:     result+=" Type"; break;
        case ClassDef::Union:      result+=" Union"; break;
        case ClassDef::Interface:  result+=" Interface"; break;
        case ClassDef::Protocol:   result+=" Protocol"; break;
        case ClassDef::Category:   result+=" Category"; break;
        case ClassDef::Exception:  result+=" Exception"; break;
        default: break;
      }
      if (isTemplate) result+=" Template";
      result+=" Tham chiếu";
      return result;
    }
    /*! used as the title of the HTML page of a module (Fortran) */
    OGString trModuleReference(const OGString &namespaceName) override
    {
      OGString result=namespaceName;
      result+=" Tham chiếu Module";
      return result;
    }

    /*! This is put above each page as a link to all members of modules. (Fortran) */
    OGString trModulesMembers() override
    { return "Thành viên Module"; }

    /*! This is an introduction to the page with all modules members (Fortran) */
    OGString trModulesMemberDescription(bool extractAll) override
    {
      OGString result="Danh sách tất cả ";
      if (!extractAll) result+="(đã được mô tả) ";
      result+="các module thành viên cùng với liên kết tới ";
      if (extractAll)
      {
        result+="Thông tin module cho từng thành viên:";
      }
      else
      {
        result+="các module thuộc:";
      }
      return result;
    }

    /*! This is used in LaTeX as the title of the chapter with the
     *  index of all modules (Fortran).
     */
    OGString trModulesIndex() override
    { return "Chỉ mục các Module"; }

    /*! This is used for translation of the word that will possibly
     *  be followed by a single name or by a list of names
     *  of the category.
     */
    OGString trModule(bool first_capital, bool singular) override
    {
      return createNoun(first_capital, singular, "module", "");
    }
    /*! This is put at the bottom of a module documentation page and is
     *  followed by a list of files that were used to generate the page.
     */
    OGString trGeneratedFromFilesFortran(ClassDef::CompoundType compType,
        bool single) override
    { // here s is one of " Module", " Struct" or " Union"
      // single is true implies a single file
      OGString result="Thông tin cho ";
      switch(compType)
      {
        case ClassDef::Class:      result+="module"; break;
        case ClassDef::Struct:     result+="type"; break;
        case ClassDef::Union:      result+="union"; break;
        case ClassDef::Interface:  result+="interface"; break;
        case ClassDef::Protocol:   result+="protocol"; break;
        case ClassDef::Category:   result+="category"; break;
        case ClassDef::Exception:  result+="exception"; break;
        default: break;
      }
      result+=" được biên soạn từ các file sau đây";
      if (single) result+=":"; else result+="s:";
      return result;
    }
    /*! This is used for translation of the word that will possibly
     *  be followed by a single name or by a list of names
     *  of the category.
     */
    OGString trType(bool first_capital, bool singular) override
    {
      return createNoun(first_capital, false, "kiểu", "");
    }
    /*! This is used for translation of the word that will possibly
     *  be followed by a single name or by a list of names
     *  of the category.
     */
    OGString trSubprogram(bool first_capital, bool singular) override
    {
      return createNoun(first_capital, singular, "chương trình con", "");
    }

    /*! C# Type Constraint list */
    OGString trTypeConstraints() override
    {
      return "Ràng buộc của kiểu (Type)";
    }

    OGString trDayOfWeek(int dayOfWeek, bool, bool full) override
    {
      static const char *days_short[]   = { "T2", "T3", "T4", "T5", "T6", "T7", "CN" };
      static const char *days_full[]    = { "Thứ Hai", "Thứ Ba", "Thứ Tư", "Thứ Năm", "Thứ Sáu", "Thứ Bảy", "Chủ Nhật" };
      OGString text  = full? days_full[dayOfWeek-1] : days_short[dayOfWeek-1];
      return text;
    }
    OGString trMonth(int month, bool, bool full) override
    {
      static const char *months_short[] = { "Thg1", "Thg2", "Thg3", "Thg4", "Thg5", "Thg6", "Thg7", "Thg8", "Thg9", "Thg10", "Thg11", "Thg12" };
      static const char *months_full[]  = { "Tháng Giêng", "Tháng Hai", "Tháng Ba", "Tháng Tư", "Tháng Năm", "Tháng Sáu", "Tháng Bảy", "Tháng Tám", "Tháng Chín", "Tháng Mười", "Tháng Mười Một", "Tháng Mười Hai" };
      OGString text  = full? months_full[month-1] : months_short[month-1];
      return text;
    }
    OGString trDayPeriod(bool period) override
    {
      static const char *dayPeriod[] = { "SA", "CH" };
      return dayPeriod[period?1:0];
    }
};

#endif
